!function(t) {
"use strict";
var e = [], o = [], n = [], i = [], a = null, r = null, s = null, l = null, c = (d.prototype._cleanup = function() {
e = [], n = [], this.node.removeAllChildren();
}, d.prototype.getChildren = function() {
return this.node.children;
}, d.prototype.tooltip = function(t, e, o) {
var n;
void 0 === e && (e = 2), void 0 === o && (o = 0), s || (n = cc.find("Canvas/UI"), 
s = Global.Loader.getInstantiate("UI/ToolTip"), n.addChild(s, 99)), s.getComponentInChildren(cc.Label).string = t, 
s.opacity = 255, s.stopAllActions(), s.y = o, s.runAction(cc.sequence(cc.delayTime(.8 * e), cc.spawn(cc.moveBy(.2 * e, cc.v2(0, 40)), cc.fadeOut(.2 * e))));
}, d.prototype.alert = function(t) {
t = {
title: t.title || "警告",
message: t.message || "警告文字",
isMask: t.isMask || !0,
okText: t.okText || "确认",
okFunction: t.okFunction || function() {},
closeFunction: t.closeFunction || function() {}
};
l || (l = Global.Loader.getInstantiate("UI/Confirm"), cc.find("Canvas/UI").addChild(l, 99)), 
l.active = !0, l.getComponent("Component").setOptions(t);
}, d.prototype.addUI = function(t) {
t = Global.Loader.getInstantiate(t);
return this.node.addChild(t), t;
}, d.prototype.pushUI = function(t, o, n) {
return e.push({
name: t,
script: o = void 0 === o ? null : o,
options: n = void 0 === n ? null : n
}), this._updateWindow();
}, d.prototype.pushWindow = function(t, e, o) {
return n.push({
name: t,
script: e = void 0 === e ? null : e,
options: o = void 0 === o ? null : o
}), this._updateEject();
}, d.prototype.getAllWindow = function(t) {
return i.filter(function(e) {
return !t || e.name == t;
});
}, d.prototype.popUI = function() {
var t, n, i = 0 < o.length ? o[o.length - 1] : null;
i ? (e.pop(), t = this, i.emit("onExitWindowBegin"), this.isEjectAnimate = !0, this.node.runAction(cc.sequence(cc.delayTime(.5), cc.callFunc(function() {
i.emit("onExitWindowEnd"), t.isEjectAnimate = !1, t._updateWindow();
}))), o.pop(), Global.Event.emit(GlobalEvent.UI_WINDOW_CHANGE, o), n = 0 < o.length ? o[o.length - 1] : null, 
a = n ? (n.emit("onEnterWindowBegin"), n.emit("onWindowFocus"), n) : null) : cc.warn("ui都没有，还移除什么");
}, d.prototype.popWindow = function(t) {
for (var e = i.length, o = i.length - 1; 0 <= o; o--) if (!t || i[o] == t) return Global.Log("popWindow start:", i[o].name), 
i[o].emit("onExitWindowBegin"), i[o].runAction(cc.sequence(cc.delayTime(.3), cc.callFunc(function(t) {
t.emit("onExitWindowEnd"), Global.Log("popWindow end:", t.name);
}))), i.splice(o, 1), Global.Event.emit(GlobalEvent.UI_WINDOW_CHANGE, i), o == e - 1 && 0 < i.length && (r = i[i.length - 1]).emit("onWindowFocus"), 
!0;
return !1;
}, d.prototype.shiftUI = function(t) {
void 0 === t && (t = 0);
for (var n = o.length - 1; t <= n; ) {
var i = 0 < o.length ? o[n] : null;
if (!i) {
cc.warn("ui都没有，还移除什么");
break;
}
e.splice(n, 1);
var a = this;
i.emit("onExitWindowBegin"), this.node.runAction(cc.sequence(cc.delayTime(.5), cc.callFunc(function() {
i.emit("onExitWindowEnd"), a._updateWindow();
}))), o.splice(n, 1), n--;
}
}, d.prototype.shiftWindow = function(t) {
void 0 === t && (t = 0);
var e = i.length;
Global.Log("shiftWindow:", t);
for (var o = i.length - 1; t <= o; o--) i[o].emit("onExitWindowBegin"), i[o].runAction(cc.sequence(cc.delayTime(.3), cc.callFunc(function(t) {
t.emit("onExitWindowEnd"), Global.Log("popWindow end:", t.name);
}))), i.splice(o, 1), o == e - 1 && 0 < i.length ? (r = i[i.length - 1]).emit("onWindowFocus") : r = null;
return Global.Event.emit(GlobalEvent.UI_WINDOW_CHANGE, i), !1;
}, d.prototype.postFocus = function() {
var t = 0 < o.length ? o[o.length - 1] : null;
t && t.emit("onWindowFocus");
}, d.prototype._updateWindow = function() {
if (0 == e.length) return null;
var t = e.pop();
this.isEjectAnimate = !0;
var o = Global.Loader.get(t.name);
if (!o) return Global.Event.emit(GlobalEvent.UI_TOOLTIP, "未找到预制件:" + t.name), console.error("未找到预制件:", t.name);
if (o instanceof cc.Prefab == 0) return Global.Event.emit(GlobalEvent.UI_TOOLTIP, "pushUI中取值不是预制值:" + t.name), 
console.error("pushUI中取值不是预制值:", t.name);
var n = cc.instantiate(o);
return this.node.addChild(n), this._addUIAnimate(n), t.script && !t.options && (t.options = t.script, 
t.script = t.name.substring(t.name.lastIndexOf("/") + 1)), t.script && "string" == typeof t.script ? !t.options || (o = n.getComponent(t.script)) && o.setOptions(t.options) : n.tss && n.tss && n.tss.setOptions && n.tss.setOptions(t.script), 
a && a.emit("onLoseFocus"), a = n;
}, d.prototype._addUIAnimate = function(t) {
var e = this, n = null;
(n = 0 < o.length ? o[o.length - 1] : n) ? n._uimgrloadEnd ? (n.emit("onExitWindowBegin"), 
this.node.runAction(cc.sequence(cc.delayTime(.5), cc.callFunc(function() {
n.onExitWindowEnd && n.onExitWindowEnd(), n._uimgrloadEnd = !0, e.isEjectAnimate = !1;
})))) : (n.emit("onExitWindowBegin"), e.isEjectAnimate = !1) : this.isEjectAnimate = !1, 
this.node.runAction(cc.sequence(cc.delayTime(.01), cc.callFunc(function() {
t.emit("onEnterWindowBegin");
}))), o.push(t), Global.Event.emit(GlobalEvent.UI_WINDOW_CHANGE, o), this._updateWindow();
}, d.prototype._updateEject = function() {
if (0 < n.length) {
r && r.emit("onLoseFocus");
var t = n.pop(), e = Global.Loader.get(t.name);
if (!e) return Global.Event.emit(GlobalEvent.UI_TOOLTIP, "未找到预制件:" + t.name), console.error("未找到预制件:", t.name);
if (e instanceof cc.Prefab == 0) return Global.Event.emit(GlobalEvent.UI_TOOLTIP, "pushWindow中取值不是预制值:" + t.name), 
console.error("pushWindow中取值不是预制值:", t.name);
var o = cc.instantiate(e);
return this.node.runAction(cc.sequence(cc.delayTime(.01), cc.callFunc(function() {
o.emit("onEnterWindowBegin");
}))), r = o, this.node.addChild(o, 10), i.push(o), Global.Event.emit(GlobalEvent.UI_WINDOW_CHANGE, i), 
this._updateEject(), t.script && "string" == typeof t.script ? !t.options || (e = o.getComponent(t.script)) && e.setOptions(t.options) : o.tss && o.tss && o.tss.setData && o.tss.setData(t.script), 
o;
}
return null;
}, d);
function d() {
this.node = null, this.isEjectAnimate = !1, this.node = cc.find("Canvas/UI");
}
function h(t, e, o) {
try {
t && t(e, o);
} catch (t) {
console.error("Http回调函数执行出错:", t);
}
}
var u = (p.prototype.setOptions = function(t, e) {
this._id = t, this.token = e;
}, p.prototype.loginGet = function(t) {
return t.data || (t.data = {}), this._id && (t.data._id = this._id, t.data.token = encodeURIComponent(this.token)), 
this.get(t);
}, p.prototype.get = function(t) {
var e = {
path: t.path || "/game/gameUser",
route: t.route || "",
data: t.data || {},
cb: t.cb || function() {},
url: t.url || this.defaultUrl,
reconnect: !!t.reconnect
};
t.route && (t.data.route = t.route);
var o = this;
t = "" + e.url + e.path + "?" + function(t) {
var e, o = "";
for (e in t) o && (o += "&"), o += e + "=" + t[e];
return o;
}(e.data);
Global.Log("httpurl:", t);
var n = cc.loader.getXMLHttpRequest();
n.open("GET", t, !0);
var i = setTimeout(function() {
n.abort && n.abort();
}, 3e4);
return n.onerror = function(t) {
e.reconnect ? setTimeout(function() {
o.get(e);
}, 1500) : h(e.cb, t, null);
}, n.onreadystatechange = function() {
if (4 === n.readyState) if (clearTimeout(i), 200 <= n.status && n.status < 300) {
var t = null;
try {
t = JSON.parse(n.response);
} catch (t) {
return h(e.cb, t, null), void cc.error("err:" + t);
}
200 === t.code ? h(e.cb, null, t.data) : (h(e.cb, t.code, t.data), cc.log("登陆失败！" + t));
} else 500 == n.status && (e.reconnect ? setTimeout(function() {
o.get(e);
}, 1500) : h(e.cb, {
status: n.status
}, null));
}, n.send(), n;
}, p.prototype.getUrl = function(t, e) {
var o = cc.loader.getXMLHttpRequest();
o.open("GET", t, !0);
var n = setTimeout(function() {
o.abort && o.abort();
}, 3e4);
return o.onerror = function(t) {
e(t);
}, o.onreadystatechange = function() {
if (4 === o.readyState) if (clearTimeout(n), 200 <= o.status && o.status < 300) {
var t = null;
try {
t = JSON.parse(o.response);
} catch (t) {
return void e(t, null);
}
200 === t.code ? e(null, t.data) : e(t.code, t.data);
} else 500 == o.status && e(o.status, o.response);
}, o.send(), o;
}, p);
function p() {
this.defaultUrl = "", this._id = "", this.token = "";
}
var f = {}, v = {}, g = {}, b = (m.prototype.init = function(t) {
this.ResCfg = t;
}, m.prototype.loadBundle = function(t, e, o) {
if (void 0 === o && (o = null), g[t]) return e && e(g[t]);
var n = this;
cc.assetManager.loadBundle(t, function(i, a) {
i ? (console.error("bundle:" + t + " 加载失败，稍后重新加载"), setTimeout(function() {
n.loadBundle(t, e, o);
}, 2e3)) : (g[t] = a, n.ResCfg[t] ? n.loadBundlePrefab(t, n.ResCfg[t], e, o) : e(a));
});
}, m.prototype.loadBundlePrefab = function(t, e, o, n) {
if (void 0 === n && (n = null), !g[t]) return cc.error("此bundle未加载:", t, ",请先使用 loadBundle");
console.log("开始加载" + t + "资源"), console.time(t + "资源加载时间"), g[t].load(e, cc.Prefab, n, function(n, i) {
if (n) console.error(t + " bundle加载失败:", n); else {
for (var a = 0; a < i.length; a++) f[e[a]] = i[a];
console.timeEnd(t + "资源加载时间"), o && o(g[t], i);
}
});
}, m.prototype.loadBundleRes = function(t, e, o, n) {
if (!g[t]) return cc.error("此bundle未加载:", t, ",请先使用 loadBundle");
g[t].load(e, o, function(e, o) {
e ? console.error(t + " bundle加载失败:", e) : n && n(g[t], o);
});
}, m.prototype.loadBundleDir = function(t, e, o, n) {
if (void 0 === n && (n = null), !g[t]) return cc.error("此bundle未加载:", t, ",请先使用 loadBundle");
var i = e.length ? e + "/" : "/";
g[t].loadDir(e || "/", cc.Prefab, n, function(e, n) {
if (e) console.error(t + " bundle加载失败:", e); else {
for (var a = 0; a < n.length; a++) f[i + n[a].name] = n[a];
o && o(g[t], n);
}
});
}, m.prototype.loadResources = function(t, e, o) {
void 0 === o && (o = null), v[t] ? e(v[t]) : this.loadResourcesArray(this.ResCfg[t], function(o) {
v[t] = o, e(o);
}, o);
}, m.prototype.loadResourcesArray = function(t, e, o) {
var n = this;
cc.loader.loadResArray(t, cc.Prefab, o, function(i, a) {
if (i) cc.error(i), cc.error("加载资源组失败，两秒后重试！"), setTimeout(function() {
n.loadResourcesArray(t, e, o);
}, 2e3); else {
for (var r = 0; r < a.length; r++) f[t[r]] = a[r];
e && e(a);
}
});
}, m.prototype.addPrefab = function(t, e) {
t && e ? f[t] = e : cc.warn("空对象不能添加");
}, m.prototype.releaseResUrl = function(t) {
cc.loader.releaseRes(t, cc.Prefab), delete f[t];
}, m.prototype.get = function(t) {
if (f[t]) return f[t];
if (-1 == t.indexOf("/")) {
var e, o = t.split("/"), n = o[o.length - 1];
for (e in f) if (0 <= e.lastIndexOf(n)) return Global.Log("模糊匹配"), f[e];
} else console.error("未找到url:", t);
return null;
}, m.prototype.getInstantiate = function(t) {
return cc.instantiate(this.get(t));
}, m.prototype.loadResourcesImage = function(t, e, o) {
t && "" != t && cc.loader.loadRes(t, cc.SpriteFrame, function(t, n) {
!t && e && e.node && (e.spriteFrame = n, o && o(t, n));
});
}, m.prototype.loadNetworkImage = function(t, e, o) {
t && "" != t && cc.loader.load("string" == typeof t ? {
url: t,
type: "png"
} : t, function(t, n) {
!t && e && e.node && (e.spriteFrame = new cc.SpriteFrame(n), o && o(t, n));
});
}, m.prototype.reset = function(t) {
if (t) for (var e in f) this.releaseResUrl(e);
f = {};
}, m);
function m() {
this.ResCfg = {};
}
var A = (y.prototype.on = function(t, e, o) {
this.events.push({
eventName: t,
fun: e,
target: o
});
}, y.prototype.off = function(t, e, o) {
if ("object" == typeof t || "function" == typeof t) return this.removeAllListeners(t);
this.events = this.events.filter(function(n) {
return n.eventName != t || n.fun !== e || n.target != o;
});
}, y.prototype.emit = function(t) {
for (var e = [], o = 1; o < arguments.length; o++) e[o - 1] = arguments[o];
this.events.filter(function(e) {
return e.eventName == t;
}).map(function(t) {
t.fun.apply(t.target, e);
}), this.events = this.events.filter(function(e) {
return e.eventName != t || e.eventName == t && !e.isOnce;
});
}, y.prototype.removeAllListeners = function(t) {
this.events = "object" == typeof t || "function" == typeof t ? this.events.filter(function(e) {
return e.target != t;
}) : this.events.filter(function(e) {
return e.eventName != t;
});
}, y.prototype.once = function(t, e, o) {
this.events.push({
eventName: t,
fun: e,
target: o,
isOnce: !0
});
}, y.prototype.clean = function() {
this.events = [];
}, y);
function y() {
this.events = [];
}
var E = (Object.defineProperty(w.prototype, "musicVolume", {
get: function() {
return this._musicVolume;
},
set: function(t) {
this._musicVolume = t, cc.audioEngine.setVolume(this._lastMusic, t), cc.sys.localStorage.setItem("muiscVolume", t);
},
enumerable: !1,
configurable: !0
}), Object.defineProperty(w.prototype, "soundVolume", {
get: function() {
return this._soundVolume;
},
set: function(t) {
this._soundVolume = t, cc.sys.localStorage.setItem("soundVolume", t);
},
enumerable: !1,
configurable: !0
}), Object.defineProperty(w.prototype, "musicOpen", {
get: function() {
return this._musicOpen;
},
set: function(t) {
this._musicOpen != t && (this._musicOpen = t, cc.sys.localStorage.setItem("musicOpen", t ? "1" : "0"), 
t ? this.playMusic(this._loadChip) : this.stopMusic());
},
enumerable: !1,
configurable: !0
}), Object.defineProperty(w.prototype, "soundOpen", {
get: function() {
return this._soundOpen;
},
set: function(t) {
this._soundOpen = t, cc.sys.localStorage.setItem("soundOpen", t ? "1" : "0");
},
enumerable: !1,
configurable: !0
}), Object.defineProperty(w.prototype, "vibrateOpen", {
get: function() {
return this._vibrateOpen;
},
set: function(t) {
this._vibrateOpen = t, cc.sys.localStorage.setItem("vibrateOpen", t ? 1 : 0);
},
enumerable: !1,
configurable: !0
}), w.prototype.setAudioBundle = function(t) {
this.audioBundle = t;
}, w.prototype.playMusic = function(t, e, o) {
void 0 === e && (e = null), void 0 === o && (o = .5);
var n, i = this.relativePath + t;
if (this._loadChip = t, this._lastChip = i, cc.audioEngine.setMusicVolume(o), this._arrResMusic[i]) return this.stopMusic(), 
void this.playBackground(this._arrResMusic[i], e);
"string" == typeof i ? (n = this).loadAudio(i, function(t) {
i == n._lastChip && (n.stopMusic(), n.playBackground(t, e)), n._arrResMusic[i] = t;
}) : cc.log("只支持path类");
}, w.prototype.loadAudio = function(t, e) {
this.audioBundle ? this.audioBundle.load(t, function(t, o) {
t ? cc.warn("声音加载失败:", t) : e(o);
}) : cc.loader.loadRes(t, function(t, o, n) {
o ? cc.warn("声音加载失败:", o) : e(n);
}.bind(this, t));
}, w.prototype.playSound = function(t, e, o) {
void 0 === e && (e = null), void 0 === o && (o = 1);
var n, i = this.relativePath + t;
this._arrResSound[i] ? (t = this.playEffect(this._arrResSound[i], o), e && e(t)) : "string" == typeof i ? (n = this).loadAudio(i, function(t) {
var a = n.playEffect(t, o);
e && e(a), n._arrResSound[i] = t;
}) : cc.log("只支持path类");
}, w.prototype.playBackground = function(t, e) {
this._musicOpen && (this._lastMusic = cc.audioEngine.playMusic(t, !0), e && e(this._lastMusic));
}, w.prototype.playEffect = function(t, e) {
if (this._soundOpen) {
var o;
Global.Platform.isHuaWei && (cc.url.raw(t.nativeUrl), (o = Global.api.createInnerAudioContext()).src = "resource/assets/bg.mp3", 
o.play());
t = cc.audioEngine.playEffect(t, !1);
return cc.audioEngine.setVolume(t, this._soundVolume * e), t;
}
return -1;
}, w.prototype.stopMusic = function() {
null != this._lastMusic && cc.audioEngine.stopMusic(), this._lastMusic = null;
}, w);
function w() {
this._musicOpen = !1, this._soundOpen = !1, this._vibrateOpen = !0, this._musicVolume = 0, 
this._soundVolume = 0, this._lastMusic = 0, this._arrResSound = {}, this._arrResMusic = {}, 
this._loadChip = {}, this._lastChip = {}, this.relativePath = {}, this.audioBundle = null;
var t = cc.sys.localStorage.getItem("musicOpen"), e = cc.sys.localStorage.getItem("soundOpen"), o = cc.sys.localStorage.getItem("musicVolume"), n = cc.sys.localStorage.getItem("soundVolume"), i = cc.sys.localStorage.getItem("vibrateOpen");
this._musicOpen = !t || 1 == t, this._soundOpen = !e || 1 == e, this._musicVolume = o || 1, 
this._soundVolume = n || 1, this._vibrateOpen = !i || 1 == i, "number" != typeof this._musicVolume && (this._musicVolume = 1), 
"number" != typeof this._soundVolume && (this._soundVolume = 1), this._lastMusic = null, 
this._arrResSound = {}, this._arrResMusic = {}, this._loadChip = "", this.relativePath = "audio/";
}
var G = (_.prototype.clamp = function(t, e, o) {
return Math.min(o, Math.max(t, e));
}, _.prototype.assign = function(t, e) {
for (var o in e) t[o] = e[o];
return t;
}, _.prototype.subSectionString = function(t, e) {
for (var o = 0, n = "", i = 0, a = 0; a < t.length; a++) {
var r = t.charCodeAt(a);
127 < r || 94 == r ? i += 2 : i++, e < i && (n += t.substring(o, a) + "\n", i = 0, 
o = a);
}
return n + t.substring(o, t.length);
}, _.prototype.deepCopy = function(t, e) {
if (null == t || null == t) return null;
for (var o in e = e || {}, t) t[o] && "object" == typeof t[o] ? (t[o].constructor === Array ? e[o] = [] : e[o] = {}, 
this.deepCopy(t[o], e[o])) : e[o] = t[o];
return e;
}, _.prototype.stringFormat = function(t) {
for (var e = [], o = 1; o < arguments.length; o++) e[o - 1] = arguments[o];
var n = t;
if (0 < e.length) for (var i, a = 0; a < e.length; a++) null != e[a] && (i = new RegExp("({)" + a + "(})", "g"), 
n = n.replace(i, e[a]));
return n;
}, _.prototype.getAngle = function(t, e) {
if (t.fuzzyEquals(e, .01)) return 0;
if (t.x == e.x) return e.y > t.y ? Math.PI / 2 : Math.PI;
var o = Math.abs(Math.atan((e.y - t.y) / (e.x - t.x)));
return e.x < t.x ? o = e.y > t.y ? Math.PI - o : Math.PI + o : e.y < t.y && (o = 2 * Math.PI - o), 
o;
}, _.prototype.readJson = function(t) {
if ("object" == typeof t) return t.json;
var e = t;
if (!e) return cc.warn("没有数据啊:", e), null;
for (var o = "", n = 0; ;) {
e.substring(0, n + 1);
var i = e.indexOf("//", n), a = e.indexOf("/*", n), r = 0;
if (0 <= i) r = 0 <= a ? Math.min(i, a) : i; else {
if (!(0 <= a)) {
o += e.substring(n);
break;
}
r = a;
}
r == i ? (t = e.indexOf("\n", i + 2), o += e.substring(n, i), n = t + 2) : r == a && (t = e.indexOf("*/", a + 2), 
o += e.substring(n, a), n = t + 2);
}
try {
return JSON.parse(o);
} catch (t) {
return console.error("json parseerror:", t, o), null;
}
}, _.prototype.calcDetailDay = function(t, e) {
t = new Date(t.getFullYear() + "/" + (t.getMonth() + 1) + "/" + t.getDate()).getTime(), 
e = new Date(e.getFullYear() + "/" + (e.getMonth() + 1) + "/" + e.getDate()).getTime();
return Math.floor((e - t) / 864e5);
}, _.prototype.addButtonHandler = function(t, e, o, n) {
if (!t) return console.warn("没有节点怎么添加触摸"), null;
var i = t.name.substring(t.name.indexOf("<") + 1, t.name.indexOf(">")), a = new cc.Component.EventHandler();
return a.target = t, a.component = i, a.handler = o, a.customEventData = n, e.clickEvents.push(a), 
e;
}, _.prototype.getLocation = function(t) {
return (t = t.getLocation()).x = t.x - cc.winSize.width / 2, t.y = t.y - cc.winSize.height / 2, 
t;
}, _.prototype.getNodeBox = function(t) {
t = (e = t.getBoundingBoxToWorld()).x + e.width / 2 - cc.winSize.width / 2;
var e = e.y + e.height / 2 - cc.winSize.height / 2;
return cc.v2(t, e);
}, _.prototype.getRandom = function(t, e) {
return Math.random() * (e - t) + t;
}, _.prototype.getRandomNumber = function(t, e) {
return t = Math.ceil(t), e = Math.floor(e), Math.floor(Math.random() * (e - t + 1)) + t;
}, _.prototype.NoToChinese = function(t) {
var e = "";
if (t < 0 && (t = -t, e = "负"), !/^\d*(\.\d*)?$/.test("" + t)) return cc.warn("数字错误"), 
"数字错误";
var o = new Array("零", "一", "二", "三", "四", "五", "六", "七", "八", "九"), n = new Array("", "十", "百", "千", "万", "亿", "点", ""), i = "", a = ("" + t).replace(/(^0*)/g, "").split(".");
t = Math.floor(t);
for (var r = function(t) {
for (var e = t.toString().split("").reverse(), i = "", a = 0; a < e.length; a++) i = (0 == a && 0 == e[a] || 0 < a && 0 == e[a] && 0 == e[a - 1] ? "" : o[e[a]] + (0 == e[a] ? n[0] : n[a])) + i;
return i;
}, s = a[0].length - 1; 0 <= s; s--) {
var l = Math.floor(t / 1e4), c = t % 1e4;
c.toString().length < 4 && (c = "0" + c), i = l ? r(l) + "万" + r(c) : r(t);
}
if ("" == i && (i = o[0]), 1 < a.length) {
i += n[6];
for (s = 0; s < a[1].length; s++) i += o[a[1].charAt(s)];
}
return e + i;
}, _.prototype.shuffle = function(t) {
for (var e = t.length; e; ) {
var o = Math.floor(Math.random() * e--), n = [ t[e], t[o] ];
t[o] = n[0], t[e] = n[1];
}
return t;
}, _.prototype.toPosition = function(t) {
if (void 0 === t && (t = {
x: 0,
y: 0,
width: 0,
height: 0
}), !CC_WECHATGAME) return t;
var e = wx.getSystemInfoSync(), o = cc.winSize.width, n = cc.winSize.height, i = e.screenWidth, a = e.screenHeight;
return (e = {
x: 0,
y: 0,
width: 0,
height: 0
}).x = (o / 2 - t.width / 2 + t.x) / o * i, e.y = (n / 2 - t.height / 2 - t.y) / n * a, 
e.width = t.width / o * i, e.height = t.height / n * a, e;
}, _);
function _() {}
var I = (C.prototype._initInterstitialAD = function() {
var t, e, o = this;
!this.config.interstitial || (t = Object.keys(this.config.interstitial)).length && Global.api.createInterstitialAd && (e = this.getRandomId(this.config.interstitial), 
console.log("interstitialAd key:", e), this.interstitialAd = Global.api.createInterstitialAd({
adUnitId: this.config.interstitial[t[0]]
}), this.interstitialAd && (this.interstitialAd.onClose(function() {
o.interstitialCB && o.interstitialCB();
}), this.interstitialAd.onError(function(t) {
o.interstitialCB && o.interstitialCB(t);
})));
}, C.prototype.getRandomId = function(t) {
return (t = Object.keys(t))[Math.floor(Math.random() * t.length)];
}, C.prototype.startRecordVoice = function() {}, C.prototype.stopRecordVoice = function() {}, 
C.prototype.getLaunchData = function() {
return {};
}, C.prototype.getReferrer = function() {
return {};
}, C.prototype.autoLogin = function(t) {
t({
openid: Math.floor(1e6 * Math.random()) + 8999999
});
}, C.prototype.updateVersion = function() {}, C.prototype.getUserInfo = function() {}, 
C.prototype.destroyLoginButton = function() {}, C.prototype.share = function() {}, 
C.prototype.vibrateLong = function() {}, C.prototype.vibrateShort = function() {}, 
C.prototype.reportData = function() {}, C.prototype.showBanner = function() {}, 
C.prototype.showBannerPos = function() {}, C.prototype.destroyBanner = function() {}, 
C.prototype._onVideoClose = function(t) {
this.videoAd && (this.videoAd.offError(this.onVideoError), this.videoAd.offClose(this.onVideoClose)), 
this.videoAd = null, t.isEnded ? Global.Event.emit(GlobalEvent.API_VIDEO_SUCCESS, this.lastVideoName) : Global.Event.emit(GlobalEvent.API_VIDEO_FAIL, this.lastVideoName), 
t.isEnded ? this.videoCB && this.videoCB() : this.videoFailCB ? this.videoFailCB() : Global.Event.emit("UI提示", {
content: "视频未看完不能获得奖励"
}), this.lastVideoTime = Date.now(), Global.Event.emit(GlobalEvent.API_ON_SHOW), 
t.isEnded && Statics.addEvent("视频观看成功"), this.lastVideoName = "";
}, C.prototype._onVideoError = function(t) {
this.videoAd && (this.videoAd.offError(this.onVideoError), this.videoAd.offClose(this.onVideoClose)), 
this.videoAd = null, console.error("_onVideoError:", t), Global.Event.emit(GlobalEvent.API_VIDEO_NO_RES, this.lastVideoName), 
this.videoFailCB && this.videoFailCB(null), Global.Event.emit(GlobalEvent.API_ON_SHOW), 
Global.Event.emit(GlobalEvent.UI_TOOLTIP, "广告资源不足，请稍后再试:" + t.errCode), this.lastVideoName = "";
}, C.prototype.showRewardVideo = function(t, e) {
Global.Event.emit(GlobalEvent.API_VIDEO_SUCCESS), e(!0);
}, C.prototype.showInterstitial = function() {}, C.prototype.shareRecordVideo = function() {}, 
C.prototype.startRecord = function() {}, C.prototype.stopRecord = function() {}, 
C.prototype.createAppBox = function() {}, C);
function C(t) {
this.__className__ = "Platform", this.name = "web", this.isWeb = !1, this.isWechat = !1, 
this.isTouTiao = !1, this.isQuTouTiao = !1, this.isVivo = !1, this.isOppo = !1, 
this.isQQ = !1, this.isKS = !1, this.isBaiDu = !1, this.isHuaWei = !1, this.isAndroid = !1, 
this.isIOS = !1, this.isRecordVoice = !1, this.config = {}, this.os = "", this.bannerAD = null, 
this.videoAd = null, this.bannerCfg = {}, this.interstitialAd = null, this.interstitialCB = null, 
this.videoCB = null, this.videoFailCB = null, this.lastVideoTime = 0, this.lastVideoName = "", 
this.onVideoError = null, this.onVideoClose = null, this.lastInterstitialTime = 0, 
this.config = t, this.isWeb = !0, this.onVideoError = this._onVideoError.bind(this), 
this.onVideoClose = this._onVideoClose.bind(this);
}
var D = function(t, e) {
return (D = Object.setPrototypeOf || {
__proto__: []
} instanceof Array && function(t, e) {
t.__proto__ = e;
} || function(t, e) {
for (var o in e) e.hasOwnProperty(o) && (t[o] = e[o]);
})(t, e);
};
function O(t, e) {
function o() {
this.constructor = t;
}
D(t, e), t.prototype = null === e ? Object.create(e) : (o.prototype = e.prototype, 
new o());
}
var R, N, B = (O(L, R = I), L.prototype.getLaunchData = function() {
return this.luanchData;
}, L.prototype.getReferrer = function() {
return this.referrerInfo;
}, L.prototype.autoLogin = function(t) {
var e = this;
Global.api.login({
success: function(o) {
o.gameid = Statics.gameid, Global.Http.get({
path: "/wxLogin",
route: "",
data: o,
cb: function(o, n) {
o ? (console.error("微信登陆失败:", o), setTimeout(function() {
e.autoLogin(t);
}, 1e3)) : (console.log("wxlogin登陆成功:", n), t(n));
}
});
},
fail: function(o) {
console.error("获取code失败:", o), setTimeout(function() {
e.autoLogin(t);
}, 1e3);
}
});
}, L.prototype._consoleAppIdList = function() {
Global.api.getFileSystemManager().readFile({
filePath: "app-config.json",
encoding: "utf8",
success: function(t) {
t = JSON.parse(t.data);
Global.Log("navigateToMiniProgramAppIdList:", t.navigateToMiniProgramAppIdList);
},
fail: function(t) {
console.error("navigateToMiniProgramAppIdList:", t);
}
});
}, L.prototype._checkNewVersion = function() {
var t, e = this;
this.isCheckNewVersion || ((t = Global.api.getUpdateManager()).onCheckForUpdate(function(o) {
o.hasUpdate && (e.isCheckNewVersion = !0, Global.api.showLoading({
title: "应用更新中"
}), t.onUpdateReady(function() {
Global.api.hideLoading(), t.applyUpdate();
}));
}), t.onUpdateFailed(function() {
Global.api.showToast({
title: "新版本下载失败"
}), Global.api.hideLoading();
}));
}, L.prototype.getUserInfo = function(t, e, o, n, i, a) {
Global.Log("getUserInfo:", t, e, o, n), this.btnLogin && this.btnLogin.destroy();
var r = !0;
Global.api.getSystemInfoSync(), this.btnLogin = Global.api.createUserInfoButton({
type: "image",
image: i,
style: {
left: t,
top: e,
width: o,
height: n
},
withCredentials: !0
});
var s = "";
return Global.api.login({
success: function(t) {
s = t.code;
},
fail: function() {}
}), this.btnLogin.onTap(function(t) {
if (console.log("onTap", t), !t.iv) return r && a(t), void (r = !1);
t = {
code: s,
userInfo: t.userInfo,
iv: encodeURIComponent(t.iv),
encryptedData: encodeURIComponent(t.encryptedData),
signature: t.signature
};
r && a(t), r = !1;
}), this.btnLogin.show(), this.btnLogin;
}, L.prototype.destroyLoginButton = function() {
this.btnLogin && this.btnLogin.destroy(), this.btnLogin = null;
}, L.prototype.share = function(t) {
var e = "number" == typeof t ? this.config.shareCfg[t] : "object" == typeof t ? t : (t = Math.floor(Math.random() * this.config.shareCfg.length), 
this.config.shareCfg[t]);
Global.api.shareAppMessage(e);
}, L.prototype.showBanner = function(t, e, o) {
var n = this.config.banner[t];
console.log("showBanner:", t, "->", n), this.bannerCfg = {
adName: t,
wwidth: e,
hheight: o
}, this.bannerCanShow = !0;
var i = Global.api.getSystemInfoSync(), a = (o = o || .17 * i.screenHeight, e = e || i.screenWidth, 
Global.api.createBannerAd({
adUnitId: n,
style: {
left: 0,
top: 0,
width: e,
height: o
}
}));
this.bannerAD = a;
var r = this;
this.bannerAD.onResize(function(e) {
return r.bannerAD ? (r.bannerAD.style.top = i.screenHeight - e.height, r.bannerAD.style.left = (i.screenWidth - e.width) / 2, 
void Global.Event.emit(GlobalEvent.API_BANNER_RESIZE, t, a, e)) : (a && a.destroy(), 
void (r.bannerAD = null));
}), this.bannerAD.onError(function(e) {
Global.Event.emit(GlobalEvent.API_BANNER_ERROR, t, a, e);
}), this.bannerAD.onLoad(function() {
Global.Event.emit(GlobalEvent.API_BANNER_ONLOAD, t, a, {
width: r.bannerAD.style.width,
height: r.bannerAD.style.height
});
});
}, L.prototype.vibrateLong = function() {
function t() {}
Global.Audio.vibrateOpen && Global.api.vibrateLong({
success: t,
fail: t,
complete: t
});
}, L.prototype.vibrateShort = function() {
function t() {}
Global.Audio.vibrateOpen && Global.api.vibrateShort({
success: t,
fail: t,
complete: t
});
}, L.prototype.destroyBanner = function(t) {
void 0 === t && (t = ""), this.bannerCanShow = !1, Global.Log("destroyBanner:", this.bannerAD, ",scene:", t), 
this.bannerAD && this.bannerAD.destroy(), this.bannerAD = null, this.bannerCfg = null;
}, L.prototype.showRewardVideo = function(t, e, o) {
var n, i = this;
this.videoAd || (Global.Event.emit(GlobalEvent.API_VIDEO_GET, t), this.lastVideoName = t, 
n = this.config.video[t], this.videoCB = e, this.videoFailCB = o, Global.Log("showRewardVideo:", t, "->", n), 
this.videoAd = Global.api.createRewardedVideoAd({
adUnitId: n
}), this.videoAd.load().then(function() {
i.videoAd.show(), Global.Event.emit(GlobalEvent.API_ON_HIDE);
}), this.videoAd.onError(this.onVideoError), this.videoAd.onClose(this.onVideoClose));
}, L.prototype.startRecordVoice = function(t) {
void 0 === t && (t = 15e3), this.isRecordVoice || (this.isRecordVoice = !0, Global.api.getRecorderManager().start({
duration: t,
sampleRate: 44100,
encodeBitRate: 64e3,
format: "mp3"
}));
}, L.prototype.stopRecordVoice = function() {
this.isRecordVoice && Global.api.getRecorderManager().stop();
}, L.prototype.showInterstitial = function() {
this.interstitialAd && this.interstitialAd.show();
}, L.prototype._getNativeAd = function(t) {
t(this.nativeCache.pop());
}, L);
function L(t) {
var e = R.call(this, t) || this;
e.__className__ = "PlatformWechat", e.name = "wechat", e.isWechat = !0, e.isWeb = !1, 
e.isEnterFromMyApp = !1, e.luanchData = null, e.referrerInfo = null, e.videoCB = null, 
e.videoFailCB = null, e.autoLoginCB = null, e.isCheckNewVersion = !1, e.btnLogin = null, 
e.bannerCanShow = !1, e.videoName = "", e.shareListener = null, e.nativeAd = null, 
e.nativeCache = [], e.isWeb = !1;
var o = window.wx;
t = Global.api.getLaunchOptionsSync();
return e.luanchData = t.query, e.referrerInfo = t.referrerInfo || {}, Global.api.onShareAppMessage(function() {
var t = Math.floor(Math.random() * e.config.shareCfg.length);
return {
title: (t = e.config.shareCfg[t]).title,
imageUrl: t.imageUrl,
imageUrlId: t.imageUrlId,
query: {}
};
}), Global.api.showShareMenu(null), Global.api.setKeepScreenOn && Global.api.setKeepScreenOn({
keepScreenOn: !0
}), e._consoleAppIdList(), setTimeout(e._checkNewVersion.bind(e), 1e3), 1089 == t.scene ? (Global.Event.emit("enterFromMyApp"), 
e.isEnterFromMyApp = !0) : 1038 == t.scene && Global.Event.emit("backOtherApp", t.referrerInfo), 
Global.api.onShow(function(t) {
Global.Event.emit(GlobalEvent.API_ON_SHOW, t);
var e = Global.api.getLaunchOptionsSync();
1089 == t.scene ? (Global.Event.emit("enterFromMyApp"), this.isEnterFromMyApp = !0) : 1038 == e.scene && Global.Event.emit("backOtherApp", e.referrerInfo), 
this.shareListener = null, this._checkNewVersion();
}.bind(e)), Global.api.onHide(function() {
Global.Event.emit(GlobalEvent.API_ON_HIDE);
}), o.getRecorderManager().onStop(function(t) {
e.isRecordVoice = !1, Global.Log("录音完成", t.tempFilePath), Global.Event.emit(GlobalEvent.RECORD_VOICE_END, t);
}), e._initInterstitialAD(), e;
}
(_t = N = N || {})["头条"] = "toutiao", _t["抖音"] = "douyin", _t["皮皮虾"] = "ppx", _t["火山"] = "huosha", 
_t["西瓜"] = "xigua", _t["开发工具"] = "devtools";
var S, V = (O(P, S = I), P.prototype.autoLogin = function(t) {
var e = {
openid: Math.floor(1e6 * Math.random()) + 8999999,
platform: "tt"
};
t && t(e);
}, P.prototype._consoleAppIdList = function() {
Global.api.getFileSystemManager().readFile({
filePath: "game.json",
encoding: "utf8",
success: function(t) {
t = JSON.parse(t.data);
Global.Log("navigateToMiniProgramAppIdList:", t.navigateToMiniProgramAppIdList);
},
fail: function(t) {
console.error("navigateToMiniProgramAppIdList:", t);
}
});
}, P.prototype.share = function(t, e) {
var o = {};
o = t && "number" == typeof t ? this.config[t] : t && "object" == typeof t ? t : (t = Math.floor(Math.random() * this.config.shareCfg.length), 
this.config.shareCfg[t]), o = JSON.parse(JSON.stringify(o));
e && (o.success = e), Global.api.shareAppMessage(o);
}, P.prototype.shareRecordVideo = function() {
window.tt.shareAppMessage({
channel: "video",
title: "视频分享",
desc: "精彩分享",
imageUrl: "",
templateId: "",
query: "",
extra: {
videoPath: this.shareVideoPath,
videoTopics: [],
withVideoId: !0
},
success: function(t) {
Global.Log(t.videoId), Global.Log("分享视频成功");
},
fail: function() {
Global.Log("分享视频失败");
}
});
}, P.prototype.showBannerPos = function(t, e, o, n, i) {
var a, r, s, l, c, d = this, h = this.config.banner[t];
Global.Log("toutiao showBanner:", t, h), h && (this.destroyBanner(), a = window.tt.getSystemInfoSync(), 
r = o || .17 * a.screenHeight, s = e || a.screenWidth, l = window.tt.createBannerAd({
adUnitId: h,
style: {
left: n,
top: i,
width: s,
height: r
}
}), this.bannerAD = l, (c = this).bannerAD.onResize(function(e) {
return c.bannerAD ? (Global.Log("getSystemInfoSync", a.screenWidth, a.screenHeight), 
Global.Log("onResize", n, i, s, r, e.width, e.height), void Global.Event.emit(GlobalEvent.API_BANNER_RESIZE, t, l, e)) : (l && l.destroy(), 
void (c.bannerAD = null));
}), this.bannerAD.onError(function(t) {
Global.Log("onError:", t), d.destroyBanner();
}), this.bannerAD.onLoad(function() {
d.bannerAD.show();
}));
}, P.prototype.vibrateLong = function() {
function t() {}
Global.Audio.vibrateOpen && Global.api.vibrateLong({
success: t,
fail: t,
complete: t
});
}, P.prototype.vibrateShort = function() {
function t() {}
Global.Audio.vibrateOpen && Global.api.vibrateShort({
success: t,
fail: t,
complete: t
});
}, P.prototype.destroyBanner = function() {
Global.Log("destroyBanner:", this.bannerAD), this.bannerAD && this.bannerAD.destroy(), 
this.bannerAD = null;
}, P.prototype._onVideoClose = function(t) {
S.prototype._onVideoClose.call(this, t), this.videoCB = null, this.videoFailCB = null;
}, P.prototype._onVideoError = function(t) {
S.prototype._onVideoError.call(this, t), this.videoCB = null, this.videoFailCB = null;
}, P.prototype.showRewardVideo = function(t, e, o) {
var n = this;
this.lastVideoName = t;
var i = this.config.video[t];
this.videoCB = e, this.videoFailCB = o, this.videoAd ? this.videoAd.load().then(function() {
n.videoAd.show(), Global.Event.emit(GlobalEvent.API_ON_HIDE);
}) : (Global.Log("showRewardVideo:", t, i), this.onVideoError = this._onVideoError.bind(this), 
this.onVideoClose = this._onVideoClose.bind(this), this.videoAd = window.tt.createRewardedVideoAd({
adUnitId: i
}), this.videoAd.load().then(function() {
n.videoAd.show();
}), this.videoAd.onError(this.onVideoError), this.videoAd.onClose(this.onVideoClose));
}, P.prototype.startRecord = function(t) {
void 0 === t && (t = 0), Global.Log("startRecord:", t), this.recordMgr.start({
duration: t
}), this._startRecordTime = Date.now(), this.isRecording = !0;
}, P.prototype.stopRecord = function() {
Global.Log("stopRecord"), this.isRecording && (this.recordMgr.stop(), this.isRecording = !1);
}, P.prototype.showInterstitial = function(t) {
this.interstitialCB = t, this.interstitialAd ? (this.interstitialCB = t, this.interstitialAd.show().catch(function(e) {
console.error(e), t && t();
})) : console.error("未提供广告id");
}, P.prototype.getRecordTime = function() {
return Date.now() - this._startRecordTime;
}, P);
function P(t) {
var e = S.call(this, t) || this;
e.__className__ = "PlatformTouTiao", e.name = "toutiao", e.isWehcat = !1, e.isWeb = !1, 
e.isTouTiao = !0, e.Host = N.头条, e.videoName = "", e.shareVideoPath = "", e._startRecordTime = 0, 
e.isRecording = !1;
t = window.tt;
return e.recordMgr = t.getGameRecorderManager(), e.recordMgr.onStop(function(t) {
return e.isRecording = !1, Date.now() - e._startRecordTime < 5e3 ? (Global.Event.emit(GlobalEvent.UI_TOOLTIP, "录制时间<5秒无效"), 
Global.Event.emit(GlobalEvent.RECORD_END, !1)) : (e.shareVideoPath = t.videoPath, 
Global.Event.emit(GlobalEvent.RECORD_END, !0)), void (e._startRecordTime = 0);
}), t.onShareAppMessage(function() {
var t = Math.floor(Math.random() * e.config.shareCfg.length);
return {
title: (t = e.config.shareCfg[t]).title,
imageUrl: t.imageUrl,
imageUrlId: t.imageUrlId,
query: ""
};
}), t.showShareMenu(null), t.setKeepScreenOn({
keepScreenOn: !0
}), e.Host = Global.api.getSystemInfoSync().appName.toLowerCase(), Global.Log("头条初始化成功,Host:", e.Host), 
e._consoleAppIdList(), e.lastInterstitialTime = Date.now(), e._initInterstitialAD(), 
e;
}
var T, M = (O(U, T = B), U.prototype.autoLogin = function(t) {
var e = {
openid: "qq" + Math.floor(1e7 * Math.random()) + 89999999,
platform: "qq"
};
t && t(e);
}, U.prototype.showBanner = function(t, e, o) {
var n = this.config.banner[t];
this.bannerCfg = {
adName: t,
wwidth: e,
hheight: o
}, Global.Log("showBanner:", t, "->", n);
var i = Global.api.getSystemInfoSync(), a = (o = o || .17 * i.screenHeight, e = e || i.screenWidth, 
Global.api.createBannerAd({
adUnitId: n,
style: {
left: 0,
top: 0,
width: e,
height: o
}
}));
this.bannerAD = a;
var r = this;
this.bannerAD.onResize(function(e) {
return r.bannerAD ? (r.bannerAD.style.top = i.screenHeight - e.height, r.bannerAD.style.left = (i.screenWidth - e.width) / 2, 
void Global.Event.emit(GlobalEvent.API_BANNER_RESIZE, t, a, e)) : (a && a.destroy(), 
void (r.bannerAD = null));
}), this.bannerAD.onError(function(e) {
Global.Event.emit(GlobalEvent.API_BANNER_ERROR, t, a, e);
}), this.bannerAD.onLoad(function() {
Global.Event.emit(GlobalEvent.API_BANNER_ONLOAD, t, a, {
width: r.bannerAD.style.width,
height: r.bannerAD.style.height
});
});
}, U.prototype.createAppBox = function(t, e) {
var o = this;
this.appBoxCB = e, this.appBox ? this.appBox.show() : (t || (t = (e = Object.keys(this.config.appBox))[Math.floor(Math.random() * e.length)]), 
Global.Log("appBoxId", this.config.appBox[t]), this.appBox = window.qq.createAppBox({
adUnitId: this.config.appBox[t]
}), this.appBox.load().then(function() {
o.appBox.show();
}), this.appBox.onClose(function() {
o.appBoxCB && o.appBoxCB();
}));
}, U.prototype.showInterstitial = function() {
this.interstitialAd && this.interstitialAd.show();
}, U);
function U(t) {
return (t = T.call(this, t) || this).isWechat = !0, t.isQQ = !1, t.name = "QQ", 
t.appBox = null, t.isQQ = !0, t.isWechat = !1, t._initInterstitialAD(), t;
}
var W, x = null, F = (O(H, W = I), H.prototype.autoLogin = function(t) {
var e = {
openid: Math.floor(1e7 * Math.random()) + 89999999,
platform: "vivo"
};
t && t(e);
}, H.prototype.vibrateLong = function() {
Global.Audio.vibrateOpen && x.vibrateLong();
}, H.prototype.vibrateShort = function() {
Global.Audio.vibrateOpen && x.vibrateShort();
}, H.prototype.showBannerPos = function(t, e, o, n, i) {
var a = this, r = this.config.banner[t];
this.bannerCfg = {
adName: t,
wwidth: e,
hheight: o
}, x.getSystemInfoSync(), this.bannerAD || (this.bannerAD = x.createBannerAd({
posId: r,
style: {
left: n,
top: i,
width: e,
height: o
}
}), this.bannerAD.onSize(function(t) {
return a.bannerAD ? void Global.Log(GlobalEvent.API_BANNER_RESIZE, t) : (a.bannerAD && a.bannerAD.destroy(), 
void (a.bannerAD = null));
}), this.bannerAD.onError(function(t) {
Global.Log("onError:", t);
})), this.bannerAD.show();
}, H.prototype.destroyBanner = function(t) {
void 0 === t && (t = ""), Global.Log("destroyBanner:", this.bannerAD, ",scene:", t), 
this.bannerAD && this.bannerAD.destroy(), this.bannerAD = null, this.bannerCfg = null;
}, H.prototype.showRewardVideo = function(t, e, o) {
if (this.lastVideoName = t, Date.now() - this.lastVideoTime < 1e4) return Global.Event.emit("UI提示", {
content: "广告资源不足，请稍后再试"
});
t = this.config.video[t];
if (this.videoCB = e, this.videoFailCB = o, this.videoAd) return this.videoAd.load();
var n = x.createRewardedVideoAd({
posId: t
});
this.videoAd = n, this.videoAd.onLoad(function() {
setTimeout(function() {
Global.Event.emit(GlobalEvent.API_ON_HIDE), n.show();
}, 50);
}), n.load(), n.onError(this.onVideoError), n.onClose(this.onVideoClose);
}, H.prototype._getNativeAd = function(t) {
t(this.nativeCache.pop());
}, H.prototype.showNativeAD = function(t, e) {
void 0 === e && (e = null);
var o = this;
this.nativeAd && 0 < this.nativeCache.length ? e && this._getNativeAd(e) : (t = this.config.native[t], 
Global.Log("showNativeAD:", t, Date.now()), (t = x.createNativeAd({
posId: t
})).onLoad(function(t, e) {
Global.Log("原生广告加载完成-onload触发", e), e && e.adList && e.adList.length && (o.nativeCache = e.adList, 
t && o._getNativeAd(t));
}.bind(null, e)), t.onError(function(t) {
Global.Log("原生广告加载异常", t);
}), this.nativeAd = t);
}, H.prototype.showInterstitial = function(t) {
this.interstitialAd ? (this.interstitialCB = t, this.interstitialAd.show().catch(function(e) {
console.error(e), t && t();
})) : console.error("未提供广告id");
}, H);
function H(t) {
return (t = W.call(this, t) || this).isWeb = !1, t.isVivo = !1, t.name = "vivo", 
t.videoName = "", t.nativeAd = null, t.nativeCache = [], t.isWeb = !1, t.isVivo = !0, 
x = window.qg, Global.Log("vivo平台初始化"), Global.api.onShow(function(t) {
Global.Event.emit(GlobalEvent.API_ON_SHOW, t);
}), Global.api.onHide(function() {
Global.Event.emit(GlobalEvent.API_ON_HIDE);
}), t._initInterstitialAD(), t;
}
var k, j = null, q = (O(z, k = I), z.prototype.readVersion = function() {
var t = j.getFileSystemManager().readFileSync("manifest-1.json", "utf8");
t && (t = JSON.parse(t), j.dataversion = t.versionName, console.log("qg readVersion:", j.dataversion));
}, z.prototype.autoLogin = function(t) {
var e = {
openid: "op" + Math.floor(1e7 * Math.random()) + 89999999,
platform: "oppo"
};
t && t(e);
}, z.prototype.vibrateLong = function() {
Global.Audio.vibrateOpen && j.vibrateLong();
}, z.prototype.vibrateShort = function() {
Global.Audio.vibrateOpen && j.vibrateShort();
}, z.prototype.showBannerPos = function(t, e, o, n, i) {
var a = this, r = this.config.banner[t];
this.bannerCfg = {
adName: t,
wwidth: e,
hheight: o
};
t = j.getSystemInfoSync();
Global.Log("showBannerPos:", n, i, e, o), this.bannerAD || (this.bannerAD = j.createBannerAd({
adUnitId: r,
style: {
left: n / t.pixelRatio,
top: i / t.pixelRatio,
width: e / t.pixelRatio,
height: o / t.pixelRatio
}
}), this.bannerAD.onResize(function(t) {
return a.bannerAD ? void Global.Event.emit("bannershow", t) : (a.bannerAD && a.bannerAD.destroy(), 
void (a.bannerAD = null));
}), this.bannerAD.onError(function(t) {
Global.Log("onError:", t);
})), this.bannerAD.show();
}, z.prototype.destroyBanner = function(t) {
void 0 === t && (t = ""), Global.Log("destroyBanner:", this.bannerAD, ",scene:", t), 
this.bannerAD && this.bannerAD.destroy(), this.bannerAD = null, this.bannerCfg = null;
}, z.prototype.showRewardVideo = function(t, e, o) {
if (this.lastVideoName = t, Date.now() - this.lastVideoTime < 1e4) return Global.Event.emit("UI提示", {
content: "广告资源不足，请稍后再试"
});
t = this.config.video[t];
if (this.videoCB = e, this.videoFailCB = o, this.videoAd) return this.videoAd.load();
var n = j.createRewardedVideoAd({
posId: t
});
this.videoAd = n, this.videoAd.onLoad(function() {
setTimeout(function() {
n.show(), Global.Event.emit(GlobalEvent.API_ON_HIDE);
}, 50);
}), n.load(), n.onError(this.onVideoError), n.onClose(this.onVideoClose);
}, z.prototype._getNativeAd = function(t) {
t(this.nativeCache.pop());
}, z.prototype.showNativeAD = function(t, e) {
void 0 === e && (e = null);
var o = this;
this.nativeAd && 0 < this.nativeCache.length ? e && this._getNativeAd(e) : (t = this.config.native[t], 
Global.Log("showNativeAD:", t, Date.now()), (t = j.createNativeAd({
adUnitId: t
})).onLoad(function(t, e) {
Global.Log("原生广告加载完成-onload触发", e), e && e.adList && e.adList.length && (o.nativeCache = e.adList, 
t && o._getNativeAd(t));
}.bind(null, e)), t.onError(function(t) {
Global.Log("原生广告加载异常", t);
}), this.nativeAd = t);
}, z.prototype.createAppBox = function(t, e) {
var o = this;
this.appBoxCB = e, this.appBox ? this.appBox.show() : (t || (t = (e = Object.keys(this.config.appBox))[Math.floor(Math.random() * e.length)]), 
Global.Log("appBoxId", this.config.appBox[t]), this.appBox = window.qq.createAppBox({
adUnitId: this.config.appBox[t]
}), this.appBox.load().then(function() {
o.appBox.show();
}), this.appBox.onClose(function() {
o.appBoxCB && o.appBoxCB();
}));
}, z);
function z(t) {
return (t = k.call(this, t) || this).isWeb = !1, t.isOppo = !1, t.name = "oppo", 
t.videoName = "", t.nativeAd = null, t.nativeCache = [], t.isWeb = !1, t.isOppo = !0, 
Global.Log("oppo初始化"), j = window.qg, t.readVersion(), Global.api.onShow(function(t) {
Global.Event.emit(GlobalEvent.API_ON_SHOW, t);
}), Global.api.onHide(function() {
Global.Event.emit(GlobalEvent.API_ON_HIDE);
}), t;
}
var J, Q = (O(Z, J = I), Z.prototype._checkNewVersion = function() {
var t, e = this;
this.isCheckNewVersion || ((t = Global.api.getUpdateManager()).onCheckForUpdate(function(o) {
o.hasUpdate && (e.isCheckNewVersion = !0, Global.api.showLoading({
title: "应用更新中"
}), t.onUpdateReady(function() {
window.wx.hideLoading(), t.applyUpdate();
}));
}), t.onUpdateFailed(function() {
Global.api.showToast({
title: "新版本下载失败"
}), Global.api.hideLoading();
}));
}, Z.prototype.showBanner = function(t, e, o) {
var n = this.config.banner[t];
this.bannerCfg = {
adName: t,
wwidth: e,
hheight: o
}, Global.Log("showBanner:", t, "->", n);
var i = Global.api.getSystemInfoSync(), a = (o = o || .17 * i.screenHeight, e = e || i.screenWidth, 
Global.api.createBannerAd({
adUnitId: n,
appSid: this.config.appid,
style: {
left: 0,
top: 0,
width: e,
height: o
}
}));
this.bannerAD = a;
var r = this;
this.bannerAD.onResize(function(e) {
return r.bannerAD ? (r.bannerAD.style.top = i.screenHeight - e.height, r.bannerAD.style.left = (i.screenWidth - e.width) / 2, 
void Global.Event.emit(GlobalEvent.API_BANNER_RESIZE, t, a, e)) : (a && a.destroy(), 
void (r.bannerAD = null));
}), this.bannerAD.onError(function(e) {
Global.Event.emit(GlobalEvent.API_BANNER_ERROR, t, a, e);
}), this.bannerAD.onLoad(function() {
Global.Event.emit(GlobalEvent.API_BANNER_ONLOAD, t, a, {
width: r.bannerAD.style.width,
height: r.bannerAD.style.height
});
});
}, Z.prototype.vibrateLong = function() {
function t() {}
Global.Audio.vibrateOpen && Global.api.vibrateLong({
success: t,
fail: t,
complete: t
});
}, Z.prototype.vibrateShort = function() {
function t() {}
Global.Audio.vibrateOpen && Global.api.vibrateShort({
success: t,
fail: t,
complete: t
});
}, Z.prototype.showRewardVideo = function(t, e, o) {
var n = this;
this.lastVideoName = t;
var i = this.config.video[t];
if (this.videoCB = e, this.videoFailCB = o, Global.Log("showRewardVideo:", t, "->", i), 
this.onVideoError || (this.onVideoError = this._onVideoError.bind(this), this.onVideoClose = this._onVideoClose.bind(this)), 
this.videoAd) return this.videoAd.load();
this.videoAd = Global.api.createRewardedVideoAd({
adUnitId: i,
appSid: this.config.appid
}), this.videoAd.onLoad(function() {
n.videoAd.show(), Global.Event.emit(GlobalEvent.API_ON_HIDE);
}), this.videoAd.onError(this.onVideoError), this.videoAd.onClose(this.onVideoClose);
}, Z.prototype.startRecord = function(t) {
this.recordMgr.start({
duration: t = void 0 === t ? 120 : t
}), this._startRecordTime = Date.now(), this.isRecording = !0;
}, Z.prototype.stopRecord = function() {
this.recordMgr.stop();
}, Z);
function Z(t) {
var e = J.call(this, t) || this;
e.name = "baidu", e.isWechat = !1, e.isBaiDu = !0, e.isWeb = !1, e.isCheckNewVersion = !1, 
e.recordMgr = null, e.isRecording = !1, e._startRecordTime = 0, e.shareVideoPath = "", 
e.isWeb = !1, e.isBaiDu = !0;
return (t = window.swan).getLaunchOptionsSync(), t.onShareAppMessage(function() {
var t = Math.floor(Math.random() * e.config.shareCfg.length);
return {
title: (t = e.config.shareCfg[t]).title,
imageUrl: t.imageUrl,
imageUrlId: t.imageUrlId,
query: {}
};
}), t.showShareMenu(null), t.setKeepScreenOn && t.setKeepScreenOn({
keepScreenOn: !0
}), t.onShow(function(t) {
Global.Event.emit(GlobalEvent.API_ON_SHOW, t);
}.bind(e)), t.onHide(function() {
Global.Event.emit(GlobalEvent.API_ON_HIDE);
}), e.recordMgr = t.getVideoRecorderManager(), e.recordMgr.onStop(function(t) {
return e.isRecording = !1, Date.now() - e._startRecordTime < 5e3 ? (Global.Event.emit(GlobalEvent.UI_TOOLTIP, "录制时间<5秒无效"), 
Global.Event.emit(GlobalEvent.RECORD_END, !1)) : (e.shareVideoPath = t.videoPath, 
Global.Event.emit(GlobalEvent.UI_TOOLTIP, "录制时间<5秒无效"), Global.Event.emit(GlobalEvent.RECORD_END, !0)), 
void (e._startRecordTime = 0);
}), e;
}
var K = (X.API_ON_SHOW = "onShow", X.API_ON_HIDE = "onHide", X.API_VIDEO_GET = "videoGet", 
X.API_VIDEO_SUCCESS = "videoSuccess", X.API_VIDEO_FAIL = "videoFail", X.API_VIDEO_NO_RES = "videoNoRes", 
X.API_BANNER_RESIZE = "bannerResize", X.API_BANNER_ERROR = "bannerError", X.API_BANNER_ONLOAD = "banneronLoad", 
X.RECORD_END = "recordEnd", X.UI_WINDOW_CHANGE = "ui_event_window_change", X.UI_PREFAB_NOT_LOADING = "ui_event_not_loading", 
X.UI_PREFAB_NOT_PREFAB = "ui_event_not_prefab", X.UI_TOOLTIP = "tooltip", X.RECORD_VOICE_END = "recordVideoEnd", 
X.ReportEvent = {
OnlineTime: "ot",
OpenVideo: "ov",
VideoSuccess: "vs"
}, X);
function X() {}
var Y = "", $ = -1, tt = "", et = (ot.init = function(t, e, o, n) {
Y = t, $ = e, tt = o, this.platform = n, this.gameid = e;
}, ot.register = function(t, e, o, n) {
this.openid = t, this.version = o;
var i = this;
this.get("", {
openid: t,
referrerInfoAppId: e,
platform: this.platform
}, function(t, e) {
if (console.log("注册结果:", e), e && (i.flows = e.flows, i.subscribe = e.subscribe, 
i.registerTimeTick = e.registerTimeTick, Global.Event.emit("updateFlows"), e.dictionary)) for (var a = 0; a < e.dictionary.length; a++) e.dictionary[a].version == o && (i.dictionary[e.dictionary[a].key] = e.dictionary[a].value);
n(t, e);
}, "/gameRegister");
}, ot.login = function(t, e, o) {
this.openid = t, this.version = e;
var n = this;
this.get("login", {
openid: t,
version: e,
platform: this.platform
}, function(t, i) {
if (console.log("统计服务器登陆结果:", i), i && (n.flows = i.flows, n.registerTimeTick = i.registerTimeTick, 
n.subscribe = i.subscribe, Global.Event.emit("updateFlows"), i.dictionary)) for (var a = 0; a < i.dictionary.length; a++) i.dictionary[a].version == e && (n.dictionary[i.dictionary[a].key] = i.dictionary[a].value);
o && o(t, i);
});
}, ot.addFlowCount = function(t) {
t.openid = this.openid, t.platform = this.platform, this.get("addFlowCount", t, function(t, e) {
console.log("addFlowCount:", e);
});
}, ot.addFlowOpenCount = function(t) {
t.openid = this.openid, t.platform = this.platform, this.get("addFlowOpenCount", t, function(t, e) {
console.log("addFlowCount:", e);
});
}, ot.addEvent = function(t) {
this.registerTimeTick && this.get("addEvent", {
eventName: t
}, function(t, e) {
console.log("addEvent:", e);
});
}, ot.userEvent = function(t) {
this.get("userEvent", {
eventName: t
}, function(t, e) {
console.log("userEvent:", e);
});
}, ot.requestSubscribeMessage = function() {
var t = this;
this.get("subscribeSuccss", {}, function(e, o) {
t.subscribe = o.subscribe;
});
}, ot.saveCacheData = function(t) {
this.get("saveData", {
cacheData: t
}, function(t, e) {
console.log("数据保存结果:", e);
});
}, ot.get = function(t, e, o, n) {
void 0 === n && (n = "/game"), Y || console.error("admin Url is null"), e.secret = tt, 
e.gameid = $, e.openid = this.openid, Global.Http.loginGet({
path: n,
route: t,
data: e,
cb: o,
reconnect: !0,
url: Y
});
}, ot.dictionary = {}, ot.subscribe = !1, ot.openid = "", ot.gameid = 0, ot.version = "", 
ot.platform = "", ot.flows = [], ot.registerTimeTick = 0, ot);
function ot() {}
var nt, it, at = (O(rt, nt = I), rt.prototype.autoLogin = function(t) {
var e = {
openid: Math.floor(1e7 * Math.random()) + 89999999,
platform: "hw"
};
t && t(e);
}, rt.prototype.vibrateLong = function() {
Global.api.vibrateLong();
}, rt.prototype.vibrateShort = function() {
Global.api.vibrateShort();
}, rt.prototype.showBannerPos = function(t, e, o, n, i) {
var a = this.config.banner[t];
this.bannerCfg = {
adName: t,
wwidth: e,
hheight: o
};
o = (o = Global.api.getSystemInfoSync()).safeArea.height - i / cc.winSize.height * o.safeArea.height;
console.log("hua wei showBannerPos:", 0, o, 360, 57), this.bannerAD || (this.bannerAD = Global.api.createBannerAd({
adUnitId: a,
style: {
left: 0,
top: o,
width: 360,
height: 57
}
}), this.bannerAD.onError(function(t) {
console.log("onError111:", JSON.stringify(t));
}), this.bannerAD.onLoad(function() {
console.log("广告加载完成:", a);
})), this.bannerAD.show();
}, rt.prototype.destroyBanner = function(t) {
void 0 === t && (t = ""), console.log("destroyBanner:", this.bannerAD, ",scene:", t), 
this.bannerAD && this.bannerAD.destroy(), this.bannerAD = null, this.bannerCfg = null;
}, rt.prototype._onVideoClose = function(t) {
var e = this;
setTimeout(function() {
t.isEnded ? e.videoCB && e.videoCB() : e.videoFailCB ? e.videoFailCB() : Global.Event.emit("UI提示", {
content: "视频未看完不能获得奖励"
});
}, 100), this.lastVideoTime = Date.now(), this.lastVideoName = "";
}, rt.prototype._onVideoError = function(t) {
console.log("_onVideoError:", t), this.videoFailCB && this.videoFailCB(null), this.lastVideoName = "";
}, rt.prototype.showRewardVideo = function(t, e, o) {
if (!this.lastVideoName) {
this.lastVideoName = t;
t = this.config.video[t];
if (this.videoCB = e, this.videoFailCB = o, this.onVideoError || (this.onVideoError = this._onVideoError.bind(this), 
this.onVideoClose = this._onVideoClose.bind(this)), this.videoAd) return this.videoAd.load();
var n = Global.api.createRewardedVideoAd({
adUnitId: t
});
this.videoAd = n, this.videoAd.onLoad(function() {
setTimeout(function() {
n.show();
}, 50);
}), n.load(), n.onError(this.onVideoError), n.onClose(this.onVideoClose);
}
}, rt.prototype._getNativeAd = function(t) {
t(this.nativeCache.pop());
}, rt.prototype.showNativeAD = function(t, e) {
void 0 === e && (e = null);
var o = this;
this.nativeAd && 0 < this.nativeCache.length ? e && this._getNativeAd(e) : (t = this.config.native[t], 
console.log("showNativeAD:", t, Date.now()), (t = Global.api.createNativeAd({
posId: t
})).onLoad(function(t, e) {
console.log("原生广告加载完成-onload触发", e), e && e.adList && e.adList.length && (o.nativeCache = e.adList, 
t && o._getNativeAd(t));
}.bind(null, e)), t.onError(function(t) {
console.log("原生广告加载异常", t);
}), this.nativeAd = t);
}, rt);
function rt(t) {
return (t = nt.call(this, t) || this).name = "huawei", t.isHuaWei = !0, t.isWeb = !0, 
t.videoName = "", t.onVideoError = null, t.onVideoClose = null, t.nativeAd = null, 
t.nativeCache = [], t.bannerAD = null, t.videoAd = null, t.bannerCfg = {}, t.interstitialAd = null, 
t.interstitialCB = null, t.videoCB = null, t.videoFailCB = null, t.lastVideoTime = 0, 
t.lastVideoName = "", t.isWeb = !1, t.isHuaWei = !0, console.log("华为平台初始化"), Global.api.onShow(function(t) {
Global.Event.emit(GlobalEvent.API_ON_SHOW, t);
}.bind(t)), Global.api.onHide(function() {
Global.Event.emit(GlobalEvent.API_ON_HIDE);
}), t;
}
(Ct = it = it || {}).DEFAULT = "default", Ct["穿山甲"] = "穿山甲", Ct["233乐园"] = "233乐园";
var st, lt = (O(ct, st = I), ct.prototype.setChannel = function(t) {
ct.channel = t, this.config = this.orginConfig[ct.channel], this.config || console.error("没有渠道配置:", t);
}, ct.prototype.callFromJava = function(t) {
var e = this;
Global.Log("callFromJava:", t);
var o = t.split(",");
cc.director.getScheduler().schedule(function() {
"video" == o[0] ? "0" == o[1] || "1" == o[1] ? e._onVideoClose({
isEnded: "0" == o[1]
}) : e._onVideoError({
errCode: 0
}) : "banner" == o[0] && ("0" == o[1] ? e.bannerAD = o[2] : console.log("banner 显示失败:"));
}, this, .1, 0, 0, !1);
}, ct.prototype.showBannerPos = function(t) {
this.config.banner[t];
}, ct.prototype.destroyBanner = function() {}, ct.prototype.showRewardVideo = function(t, e) {
setTimeout(e, 100);
}, ct.channel = it.DEFAULT, ct);
function ct(t) {
var e = st.call(this, t) || this;
return e.name = "android", e.isWeb = !1, e.isAndroid = !0, e.javaClassName = "org/cocos2dx/javascript/AppActivity", 
e.adConfig = null, e.orginConfig = null, (e.orginConfig = t).javaClass && (e.javaClassName = t.javaClass), 
e.setChannel(ct.channel), e;
}
var dt, ht = (O(ut, dt = I), ut.prototype.showBannerPos = function(t) {
this.config.banner[t];
}, ut.prototype.destroyBanner = function() {}, ut.prototype.showRewardVideo = function() {}, 
ut);
function ut(t) {
return (t = dt.call(this, t) || this).name = "ios", t.isWeb = !1, t.isIOS = !0, 
t;
}
var pt = "autoDeskIcon", ft = (vt.canShow = function(t) {
this.lastShowButton = t, Global.Platform.isOppo || Global.Platform.isVivo ? Global.api.hasShortcutInstalled({
success: function(e) {
Global.Log("hasShortcutInstalled:", e), t && (t.active = !e);
},
fail: function() {}
}) : (Global.Platform.isQQ, t.active = !1);
}, vt.checkAdd = function(t) {
function e() {
o.lastShowButton && (o.lastShowButton.active = !1);
var e = cc.sys.localStorage.getItem(pt);
cc.sys.localStorage.setItem(pt, "11"), t(!e);
}
var o = this;
Global.Platform.isOppo || Global.Platform.isVivo ? Global.api.installShortcut({
success: function() {
Global.Log("创建成功"), setTimeout(function() {
Global.api.hasShortcutInstalled({
success: function() {
e(), Global.Event.emit(GlobalEvent.UI_TOOLTIP, {
content: "添加桌面图标成功"
});
},
fail: function() {
Global.Event.emit(GlobalEvent.UI_TOOLTIP, {
content: "添加失败"
});
}
});
}, 10);
},
fail: function() {
Global.Log("installShortcut 自动失败"), Global.api.hasShortcutInstalled({
success: function(t) {
t && (e(), Global.Event.emit(GlobalEvent.UI_TOOLTIP, {
content: "已存在桌面图标"
}));
},
fail: function() {
Global.Event.emit(GlobalEvent.UI_TOOLTIP, {
content: "添加失败"
});
}
});
}
}) : Global.Platform.isQQ && (Global.api.saveAppToDesktop ? Global.api.saveAppToDesktop({
success: function() {
e();
},
fail: function(t) {
Global.Log("err:", t), Global.Event.emit(GlobalEvent.UI_TOOLTIP, {
content: "添加失败"
});
}
}) : (Global.Event.emit(GlobalEvent.UI_TOOLTIP, {
content: "小程序版本太低"
}), t(-1)));
}, vt.lastShowButton = null, vt);
function vt() {}
var gt = (bt.preload = function(t, e) {
void 0 === t && (t = "通用"), void 0 === e && (e = null), (Global.Platform.isVivo || Global.Platform.isOppo || Global.Platform.isHuaWei) && 0 == this.cache.length && this._showNativeAD(t, e);
}, bt._onNativeload = function(t) {
Global.Log("原生广告加载完成-onload触发:", bt.evntName, JSON.stringify(t)), t && t.adList && t.adList.length && (bt.cache.push({
nativeAd: bt.loadnativeAd,
adList: t.adList
}), Global.Event.emit("native_" + bt.evntName)), bt.isPreloading = !1;
}, bt._onNativeErr = function(t) {
Global.Log("原生广告加载异常", t), bt.isPreloading = !1;
}, bt._showNativeAD = function(t, e) {
if (Global.Log("_showNativeAD evtName:", e), 0 < bt.cache.length) {
if (bt.cache[0].adList.length) return Global.Log("原生广告cache"), void Global.Event.emit("native_" + e);
bt.cache.shift();
}
bt.isPreloading || (bt.isPreloading = !0, t = Global.Platform.config.native[t], 
Global.Log("showNativeAD:", t, Date.now()), t = Global.api.createNativeAd({
posId: t,
adUnitId: t
}), bt.evntName = e, t.offLoad(bt._onNativeload), t.onLoad(bt._onNativeload), (bt.loadnativeAd = t).offError(bt._onNativeErr), 
t.onError(bt._onNativeErr), (Global.Platform.isOppo || Global.Platform.isHuaWei) && t.load());
}, bt.cache = [], bt.nativeRoundIndex = 0, bt.evntName = "", bt.loadnativeAd = "", 
bt.isPreloading = !1, bt);
function bt() {}
var mt, At = (O(yt, mt = I), yt.prototype.autoLogin = function(t) {
var e = {
openid: "ks" + Math.floor(1e7 * Math.random()) + 89999999,
platform: "ks"
};
t && t(e);
}, yt.prototype.showBanner = function(t, e, o) {
var n = this.config.banner[t];
this.bannerCfg = {
adName: t,
wwidth: e,
hheight: o
}, Global.Log("showBanner:", t, "->", n);
var i = Global.api.getSystemInfoSync(), a = (o = o || .17 * i.screenHeight, e = e || i.screenWidth, 
Global.api.createBannerAd({
adUnitId: n,
style: {
left: 0,
top: 0,
width: e,
height: o
}
}));
this.bannerAD = a;
var r = this;
this.bannerAD.onResize(function(e) {
return r.bannerAD ? (r.bannerAD.style.top = i.screenHeight - e.height, r.bannerAD.style.left = (i.screenWidth - e.width) / 2, 
void Global.Event.emit(GlobalEvent.API_BANNER_RESIZE, t, a, e)) : (a && a.destroy(), 
void (r.bannerAD = null));
}), this.bannerAD.onError(function(e) {
Global.Event.emit(GlobalEvent.API_BANNER_ERROR, t, a, e);
}), this.bannerAD.onLoad(function() {
Global.Event.emit(GlobalEvent.API_BANNER_ONLOAD, t, a, {
width: r.bannerAD.style.width,
height: r.bannerAD.style.height
});
});
}, yt.prototype.showRewardVideo = function(t, e, o) {
var n;
this.videoAd || (Global.Event.emit(GlobalEvent.API_VIDEO_GET, t), this.lastVideoName = t, 
n = this.config.video[t], this.videoCB = e, this.videoFailCB = o, Global.Log("showRewardVideo:", t, "->", n), 
this.videoAd = Global.api.createRewardedVideoAd({
adUnitId: n
}), this.videoAd.show().then(function() {
console.log("激励视频 广告显示"), Global.Event.emit(GlobalEvent.API_ON_HIDE);
}), this.videoAd.onError(this.onVideoError), this.videoAd.onClose(this.onVideoClose));
}, yt.prototype.createAppBox = function() {}, yt.prototype.startRecord = function(t) {
void 0 === t && (t = 0), Global.Log("startRecord:", t), this.recordMgr.start({
duration: t
}), this._startRecordTime = Date.now(), this.isRecording = !0;
}, yt.prototype.stopRecord = function() {
Global.Log("stopRecord"), this.isRecording && (this.recordMgr.stop(), this.isRecording = !1);
}, yt.prototype.getRecordTime = function() {
return Date.now() - this._startRecordTime;
}, yt.prototype.shareRecordVideo = function(t) {
this.recordMgr.publishVideo({
callback: t && t.callback || function(t) {
null == t || null == t ? console.log("分享录屏成功") : console.log("分享录屏失败: ", t);
},
mouldId: t && t.mouldId || "文案ID 非必填",
video: this.shareVideoPath,
query: t && t.query
});
}, yt.prototype.showInterstitial = function() {
this.interstitialAd && this.interstitialAd.show();
}, yt);
function yt(t) {
var e = mt.call(this, t) || this;
e.isWechat = !1, e.isKS = !0, e.isWeb = !1, e.name = "KS", e.appBox = null, e.videoName = "", 
e.shareVideoPath = null, e._startRecordTime = 0, e.isRecording = !1, e.isKS = !0, 
e.isWechat = !1;
t = window.ks;
return e.recordMgr = t.getGameRecorder(), e.recordMgr.on("stop", function(t) {
return e.isRecording = !1, Date.now() - e._startRecordTime < 5e3 ? (Global.Event.emit(GlobalEvent.UI_TOOLTIP, "录制时间<5秒无效"), 
Global.Event.emit(GlobalEvent.RECORD_END, !1)) : t && t.videoID ? (console.log("videoID is " + t.videoID), 
console.log("录屏停止，录制成功"), e.shareVideoPath = t.videoID, Global.Event.emit(GlobalEvent.RECORD_END, !0)) : (console.log("录屏停止，录制失败"), 
Global.Event.emit(GlobalEvent.RECORD_END, !1)), void (e._startRecordTime = 0);
}), e.recordMgr.on("error", function(t) {
console.log("录制失败", t);
}), e;
}
var Et, wt = (O(Gt, Et = I), Gt.prototype.autoLogin = function(t) {
var e = {
openid: "mz" + Math.floor(1e7 * Math.random()) + 89999999,
platform: "ks"
};
t && t(e), this._initInterstitialAD();
}, Gt.prototype._initInterstitialAD = function() {
var t, e, o = this;
!this.config.interstitial || (t = Object.keys(this.config.interstitial)).length && Global.api.createInsertAd && (e = this.getRandomId(this.config.interstitial), 
console.log("interstitialAd key:", e), this.interstitialAd = Global.api.createInsertAd({
adUnitId: this.config.interstitial[t[0]]
}), this.interstitialAd.onLoad(function() {
o.interstitialAd.show();
}), this.interstitialAd && (this.interstitialAd.onClose(function() {
o.interstitialCB && o.interstitialCB();
}), this.interstitialAd.onError(function(t) {
o.interstitialCB && o.interstitialCB(t);
})));
}, Gt.prototype.showBanner = function(t, e, o) {
var n = this.config.banner[t];
console.log("showBanner:", t, "->", n), this.bannerCfg = {
adName: t,
wwidth: e,
hheight: o
}, this.bannerCanShow = !0;
var i = Global.api.getSystemInfoSync(), a = (o = o || .17 * i.screenHeight, e = e || i.screenWidth, 
Global.api.createBannerAd({
adUnitId: n,
style: {
left: 0,
top: 0,
width: e,
height: o
}
}));
this.bannerAD = a;
var r = this;
this.bannerAD.onResize(function(e) {
return r.bannerAD ? (r.bannerAD.style.top = i.screenHeight - e.height, r.bannerAD.style.left = (i.screenWidth - e.width) / 2, 
void Global.Event.emit(GlobalEvent.API_BANNER_RESIZE, t, a, e)) : (a && a.destroy(), 
void (r.bannerAD = null));
}), this.bannerAD.onError(function(e) {
Global.Event.emit(GlobalEvent.API_BANNER_ERROR, t, a, e);
}), this.bannerAD.onLoad(function() {
Global.Event.emit(GlobalEvent.API_BANNER_ONLOAD, t, a, {
width: r.bannerAD.style.width,
height: r.bannerAD.style.height
});
});
}, Gt.prototype.destroyBanner = function(t) {
void 0 === t && (t = ""), this.bannerCanShow = !1, Global.Log("destroyBanner:", this.bannerAD, ",scene:", t), 
this.bannerAD && this.bannerAD.destroy(), this.bannerAD = null, this.bannerCfg = null;
}, Gt.prototype.showRewardVideo = function(t, e, o) {
var n, i = this;
this.videoAd || (Global.Event.emit(GlobalEvent.API_VIDEO_GET, t), this.lastVideoName = t, 
n = this.config.video[t], this.videoCB = e, this.videoFailCB = o, Global.Log("showRewardVideo:", t, "->", n), 
this.videoAd = Global.api.createRewardedVideoAd({
adUnitId: n
}), this.videoAd.load(), this.videoAd.onLoad(function() {
console.log("激励视频加载成功"), i.videoAd.show(), Global.Event.emit(GlobalEvent.API_ON_HIDE);
}), this.videoAd.onError(this.onVideoError), this.videoAd.onClose(this.onVideoClose));
}, Gt.prototype._onVideoClose = function() {
this.videoAd && (this.videoAd.offError(this.onVideoError), this.videoAd.offClose(this.onVideoClose)), 
this.videoAd = null, Global.Event.emit(GlobalEvent.API_VIDEO_SUCCESS, this.lastVideoName), 
this.videoCB && this.videoCB(), this.lastVideoTime = Date.now(), Global.Event.emit(GlobalEvent.API_ON_SHOW), 
Statics.addEvent("视频观看成功"), this.lastVideoName = "";
}, Gt.prototype.showInterstitial = function() {
this.interstitialAd && this.interstitialAd.load();
}, Gt);
function Gt(t) {
return (t = Et.call(this, t) || this).isWechat = !1, t.isMZ = !0, t.isWeb = !1, 
t.name = "MZ", t.bannerCanShow = !1, t.isMZ = !0, t.isWechat = !1, t;
}
var _t = (It._init = function(t) {
this.UIMgr = new c(), this.Audio = new E(), this.launchStartTime = Date.now(), CC_WECHATGAME ? (this.api = window.wx, 
window.tt ? this.Platform = new V(t.toutiao) : window.qq ? this.Platform = new M(t.qq) : window.ks ? this.Platform = new At(t.ks) : this.Platform = new B(t.wechat)) : cc.sys.platform == cc.sys.BAIDU_GAME ? (this.api = window.swan, 
this.Platform = new Q(t.baidu)) : cc.sys.platform === cc.sys.VIVO_GAME ? (this.api = window.qg, 
this.Platform = new F(t.vivo)) : cc.sys.platform === cc.sys.OPPO_GAME ? (this.api = window.qg, 
this.Platform = new q(t.oppo)) : cc.sys.platform == cc.sys.HUAWEI_GAME ? (this.api = window.hbs, 
this.Platform = new at(t.huawei)) : cc.sys.isNative && cc.sys.os == cc.sys.OS_ANDROID ? (this.api = {}, 
this.Platform = new lt(t.android)) : cc.sys.isNative && cc.sys.os == cc.sys.OS_IOS ? (this.api = {}, 
this.Platform = new ht(t.ios)) : window.qg ? (this.api = window.qg, this.Platform = new wt(t.mz)) : (this.api = window, 
this.Platform = new I(t.web));
t = cc.view._orientation;
console.log("isLANDSCAPE", t != cc.macro.ORIENTATION_PORTRAIT), t != cc.macro.ORIENTATION_PORTRAIT ? this.miniScreen = cc.winSize.width / cc.winSize.height < 1.4 : this.miniScreen = cc.winSize.height / cc.winSize.width < 1.4;
}, It.OpenStatics = function() {
var t = this;
cc.game.on(cc.game.EVENT_SHOW, function() {
t.launchStartTime = Date.now();
}), cc.game.on(cc.game.EVENT_HIDE, function() {
Statics.get("addEvent", {
eventName: "游戏时长",
time: Math.ceil(Date.now() - t.launchStartTime / 1e3)
}, function(t, e) {
Global.Log("游戏时长上报成功:", e);
});
});
}, It.Http = new u(), It.Loader = new b(), It.Event = new A(), It.Common = new G(), 
It.Audio = null, It.UIMgr = null, It.api = null, It.Platform = null, It.Log = console.log, 
It.miniScreen = !1, It.launchStartTime = 0, It);
function It() {}
var Ct = window;
Ct.Global = _t, Ct.UIMgr = c, Ct.Http = u, Ct.Loader = b, Ct.EventA = A, Ct.AudioA = E, 
Ct.Common = G, Ct.TTHost = N, Ct.Android_Channel = it, Ct.GlobalEvent = K, Ct.Statics = et, 
Ct.DeskIcon = ft, Ct.NativeLoader = gt, t.sdk = _t, Object.defineProperty(t, "__esModule", {
value: !0
});
}({});